package tp.etudiant.classes;

/**
 * Une classe pour crer des cellules utilises pour crer des listes simplemet chanes.
 * @author jub
 *
 * @param <X> Le type de la cellule
 */
public class Cellule<X> {
	/**
	 * La valeur de la cellule
	 */
	private X valeur;
	/**
	 * Le suivant de la cellule.
	 * Le suivant est une autre cellule ou null. 
	 */
	private Cellule<X> suivant;
	
	/**
	 * Construit une cellule vide : valeur = null et suivant = null
	 */
	public Cellule() {
		this.valeur = null;
		this.suivant = null;
	}

	public Cellule<X> getSuivant() {
		return suivant;
	}

	public X getValeur() {
		return valeur;
	}

	public void setSuivant(Cellule<X> suivant) {
		this.suivant = suivant;
	}

	public void setValeur(X valeur) {
		this.valeur = valeur;
	}

	@Override
	public String toString() {
		
		return "["+this.valeur+"]->"+this.suivant;
	} 
	
	
}
