package tp.etudiant.classes;

/**
 * Une liste simplement chane.
 * @author jub
 *
 * @param <X> Le type des lments de la liste.
 */
public class List<X>{
	private Cellule<X> tete;

	public List() {
		this.tete = new Cellule<X>(); 
	}



	private X car()
	{
		X res = null;
		if (!estVide())
			res = this.tete.getSuivant().getValeur();
		return res;
	}

	private List<X> cdr()
	{
		List<X> res = new List<X>();
		if (!estVide())
			res.tete = tete.getSuivant();
		return res;
	}

	public boolean estVide()
	{
		return this.tete.getSuivant() == null;
	}

	public X getDernier()
	{
		return this.getVal(this.getTaille()-1);
	}

	public X getPremier()
	{
		return this.getVal(0);
	}

	public int getTaille()
	{
		int res;
		if (estVide())
			res = 0;
		else
			res = 1 + this.cdr().getTaille();
		return res;
	}


	public X getVal(int pos)
	{
		X res = null;
		if (pos < this.getTaille() && pos>=0)
			if (pos==0)
				res = this.tete.getSuivant().getValeur();
			else
				res = this.cdr().getVal(pos-1);
		return res;
	}

	public void insereQueue(X val)
	{
		this.insertionPosition(val, this.getTaille()-1);
	}

	public void insereTete(X val)
	{
		this.insertionPosition(val, 0);
	}

	public void insertionPosition(X val, int pos)
	{
		if (pos <= this.getTaille())

			if (pos == 0)
			{

				Cellule<X> cellule = new Cellule<X>();
				cellule.setValeur(val);
				cellule.setSuivant(this.tete.getSuivant());
				this.tete.setSuivant(cellule);
			}
			else
				this.cdr().insertionPosition(val, pos-1);

	}
	
	public void setVal(X val,int pos)
	{
		if (pos < this.getTaille())
			if (pos==0)
				this.tete.getSuivant().setValeur(val);
			else
				this.cdr().setVal(val, pos-1);
		
	}
	
	public void suppressionPosition(int pos)
	{
		if (pos < this.getTaille() && pos >=0)
		{
			if (pos == 0)
				{
					this.tete = this.tete.getSuivant();
					//this.tete.setValeur(null);
				}
			else
			{
					List<X> l= this.cdr();
					l.suppressionPosition(pos-1);
					this.tete.getSuivant().setSuivant(l.tete.getSuivant());
			}
		}
	}
	
	public void suppressionTete()
	{
		this.suppressionPosition(0);
	}
	
	public void suppressionQueue()
	{
		this.suppressionPosition(this.getTaille()-1);
	}
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return tete.toString();
	}
}
