package tp.prof.classes;

/**
 * Une classe utilitaire qui contient des mthodes rcursives.
 * @author jub
 *
 */
public class Recursivite {

	/**
	 * Calcul rcursif du pgcd :
	 * pgcd(n,0) = n et sinon pgcd(n,m) = pgcd(m,n%m)
	 * @param n le premier paramtre
	 * @param m le second paramtre
	 * @return le pgcd du premier et du second paramtre. 
	 */
	public static int pgcd(int n, int m)
	{
		if (m==0)
			return n;
		else
			return pgcd(m,n%m);
	}
	
	/**
	 * Calcul rcursif de la factorielle : 
	 * fac(0)=fac(1)=1 et fac(n) = n * fac(n-1)
	 * @param n un entier positif
	 * @return factorille de n
	 */
	public static int fac(int n)
	{
		if (n < 2)
			return 1;
		else
			return n * fac(n-1);
	}
}
