package tp.prof.classes;

import java.util.Scanner;



/**
 * Une classe utilitaire pour manipuler des tableaux d'entiers. 
 * @author jub
 *
 */
public class TableauInt {
	public static void remplissageA(int [] t,int max)
	{
		for (int i=0; i<t.length; i++)
			t[i]=(int) (Math.random()*max);
	}
	
	public static void affiche(int [] t)
	{	
		for (int i=0; i<t.length; i++)
			System.out.println("[" +i+"]="+t[i]);
	}
	
	public static void remplissageI(int [] t)
	{	Scanner sc = new Scanner(System.in);
		for (int i=0; i<t.length; i++)
			t[i]=sc.nextInt();
	}
	
	public static int posMax(int[] t)
	{
		int pos = 0;
		for (int i=1; i < t.length; i++)
			if (t[i]>t[pos]) 
				pos=i;
		return pos;
	}
	
	public static int somme(int[] t)
	{
		int s = 0;
		for (int i=0; i<t.length; i++)
					s +=t[i];
		return s;
	}
	
	public static int rechercheS(int[] t, int elt)
	{
		int i=0;
		boolean trouve =false;
		while ((!trouve) && (i<t.length))
		{
			if (t[i]==elt)
				trouve = true;
			else
				i++;
		}
		if (trouve) 
			return i;
		else
			return -1;
		
	}
	
	public static int[] clone(int[] t)
	{
		int [] tab = new int[t.length];
		for (int i=0; i<t.length; i++)
			tab[i] = t[i];
		return tab;
	}
	
	public static int[] tri(int [] t)
	{
		int tab[] = TableauInt.clone(t);
		int m,j;
		for (int i=1; i < tab.length; i++)
		{
			m=tab[i];
			j=i;
			while ((j>0) && (tab[j-1]>m))
			{
				tab[j]=tab[j-1];
				j=j-1;
			}
			tab[j]=m;
		}
		return tab;
	}
	
	public static int rechercheDichoT(int [] t, int elt)
	{
		int inf;
		int sup;
		int milieu;
		boolean trouve;
		int position = -1;
		
		trouve = false;
		inf = 0;
		sup = t.length-1;
		while(!trouve && (inf<=sup))
		    {
			milieu = (inf+sup)/2;
			if(t[milieu] == elt)
			    {
				trouve  = true;
				position  = milieu;
			    }
			else if (t[milieu] > elt)
			    sup  = milieu - 1;
			else
			    inf = milieu + 1;
		    }
		return(position);
	}
	
	public static boolean egalite(int [] t1, int[] t2)
	{
		boolean ok=true;
		
		if (t1.length == t2.length)
		{
			int i=0;
			while ((ok) && (i <t1.length))
					if (t1[i]!=t2[i])
						ok = false;
					else
						i=i+1;
		}
		else
			ok = false;
		return ok;
	}
	
}
